******************************************************************************
*
*       Function:   GETUINFO
*       Usage:      call getuinfo (stream)
*       Purpose:    
*       Output:     
*
******************************************************************************

        subroutine getuinfo (stream)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            record /stream_info/ stream
            integer stat, dummy
            structure /uai_item/
                integer*2 buflen
                integer*2 code
                integer*4 bufaddr
                integer*4 retlen
            end structure
            record /uai_item/ uaiitems(1:5)
            integer blength
            external blength

            uaiitems(1).buflen = 4
            uaiitems(1).code = UAI$_UIC
            uaiitems(1).bufaddr = %loc (stream.uic)
            uaiitems(1).retlen = %loc (dummy)

            uaiitems(2).buflen = 8
            uaiitems(2).code = UAI$_PRIV
            uaiitems(2).bufaddr = %loc (stream.privs)
            uaiitems(2).retlen = %loc (dummy)

*           Get the username in upper case.

            uaiitems(3).buflen = len(stream.user)
            uaiitems(3).code = UAI$_USERNAME
            uaiitems(3).bufaddr = %loc (stream.user)
            uaiitems(3).retlen = %loc (dummy)

            uaiitems(4).buflen = 0
            uaiitems(4).code = 0

            stat = sys$getuai (,,
     .          %descr(stream.user(1:blength(stream.user))), uaiitems,,,)

            if ((stat.and.1).ne.1) then
                call log_sys (stat,
     .                         'User specified for queue uic not found')
                stream.uic = -1
            endif
        end
