******************************************************************************
*
*       Function:   LOG_SYS
*       Usage:      call log_sys (vms_status, string, job_structure_index)
*       Purpose:    This procedure is used when a very exceptional error
*                   occurs that requires intervention from the operator(s).
*                   log_sys calls log_str, and then writes text similiar to
*                   that written to the log file, to all PRINT operators
*                   terminals.
*       Output:     A message in the log file, as well as a message on the
*                   print operators terminals.
*
******************************************************************************

        subroutine log_sys (status, str)

            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'
            include '($opcdef)'

            integer status, descr(1:2)
            character*(*) str
            integer stat, iostat
            integer*2 len, len2
            character*(BUFSIZ) msg, buf, msg2
            integer blength
            external log_str, signal, blength

            structure /oper_req/
                integer type_target
                integer req_id
                character*(255) text
            end structure
                
            record /oper_req/ oper

*           Send the message to the logfile.

            call log_str (status, str)

*           Now send the message to the operators.

            oper.text = ' '
            oper.type_target = (256 * OPC$M_NM_PRINT) + OPC$_RQ_RQST
            oper.req_id = 0

            call signal (sys$getmsg (%val (%loc (CTLSMB__INFO)),
     .                               %ref (len), %descr (msg),,))

            call signal (sys$getmsg (%val (%loc (status)),
     .                                      %ref (len2), %descr (msg2),,))
            msg2(1:1) = '-'

            call signal (sys$fao ('!AS!/-CTLSMB-I-TEXT !AS!/!AS',
     .              %ref   (len),
     .              %descr (buf),
     .              %descr (msg(1:len)),
     .              %descr (str),
     .              %descr (msg2(1:len2))))

            stat = sys$fao (
     .              %descr (buf(1:len)),
     .              %ref   (len),
     .              %descr (oper.text),
     .              %descr (streams(last_stream).queue(
     .                      1:blength(streams(last_stream).queue))),
     .              %descr (procs(last_idx).job_name(
     .              1:blength(procs(last_idx).job_name))),
     .              %val (procs(last_idx).entry))


            descr(1) = 8 + len
            descr(2) = %loc (oper)
            call signal (sys$sndopr (descr,))
        end
