$ !  MAKEIT.COM   --   A MAKEFILE like compilation procedure
$ VER = F$VERIFY (0)
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
$ !	Author:   Gregg Wonderly
$ !     Date:     October 28, 1985
$ !	Update:   December 1986
$ !
$ !     Format:   P1 is source file (no extensions allowed)
$ !               P2 is the extension on 'p1'
$ !               P3 is compiler
$ !               P4 is alternate args, e.g. "+mylib/lib"
$ !               P5 List of dependant files (i.e. %INCLUDED files)
$ !                  For LINKs, these may be libraries etc...
$ !               P6 Error handling ("YEW") says return error on
$ !                  CONTROL-Y if Y is not in param, on error if E is not
$ !					 in param and on warning if W is not in param.
$ !
$ !               P7 Alternate OBJECT or EXE file name for /OBJ= or /EXE=
$ !               P8 Real dependant if not 'P1'.OBJ
$ !
$ !     When P3 is "LINK", then P1 is a comma separated list of .OBJ
$ !     files to be linked to form the .EXE file given by P2.  P4 is
$ !     is then the options for the LINK.  P5 and P6 apply for LINK as
$ !     described.
$ !
$ !     Returns:  $STATUS = 1 on normal EXIT operation requested was performed
$ !               $STATUS = 3 on error EXIT
$ !               $STATUS = 5 on normal EXIT no work done
$ !
$ !     The global symbol, MAKEIT$TEXT, can be set to some value. This value
$ !     will then be printed before the execution of the COMPILE or LINK
$ !     command as given by P3.  This is typically used to print "Ignore the
$ !     warning messages below" type messages. 
$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
$ IF F$MODE() .NES. "BATCH" THEN VER = F$VERIFY(VER)
$ IF F$TYPE(MAKEIT$TEXT) .EQS. "" THEN -
	MAKEIT$TEXT=""
$ SAY="WRITE SYS$OUTPUT"
$ NOW=F$CVTIME(F$TIME())
$ IF P6 .NES. "" THEN -
	P6=F$EDIT(P6,"UPCASE")
$ ONWARN = (F$LOCATE ("W", P6) .EQ. F$LENGTH (P6))
$ ONERR = (F$LOCATE ("E", P6) .EQ. F$LENGTH (P6))
$ ONCTLY = (F$LOCATE ("Y", P6) .EQ. F$LENGTH (P6))
$ MAKEIT_ERR==1
$ !
$ !  Set up default interrupt handling.
$ !
$ ON CONTROL_Y THEN GOTO DONE
$ !
$ !  Now set what the user specified.
$ !
$ IF ONCTLY THEN -
	ON CONTROL_Y THEN GOTO ERR_EXIT
$ !
$ SET CONTROL=Y
$ !
$ !  Check for LINK as command name
$ !
$ IF P3 .EQS. "LINK" THEN GOTO LINK_IT
$ !
$ !  Get the source date and check for its existance
$ !
$ SRC=F$PARSE(P1,"."+P2)
$ IF F$SEARCH(SRC) .NES. "" THEN GOTO SOURCE_EXISTS
$	WRITE SYS$OUTPUT -
		F$FAO (-
		"%MAKEIT-F-CANTFIND, can't find source file!/!_\!AS\",SRC)
$   MAKEIT_ERR== 3
$	GOTO DONE
$ !
$ SOURCE_EXISTS:
$ SOURCEDATE=F$FILE_ATTRIBUTES(SRC,"CDT")
$ !
$ !  Check the .OBJ's date, using F$SEARCH() to eliminate RMS$_FNF errors
$ !
$ OBJDATE="4-OCT-1900 00:00:00.00"
$ OBJ=F$PARSE(P1,".OBJ")
$ IF P7 .NES. "" THEN OBJ=F$PARSE(P7,".OBJ")
$ CHECKOBJ=OBJ
$ IF P8 .NES. "" THEN CHECKOBJ=F$PARSE(P8,".OBJ")
$ IF (F$SEARCH (CHECKOBJ) .NES. "") THEN -
	OBJDATE=F$FILE_ATTRIBUTES(CHECKOBJ,"CDT")
$ !
$ !  Convert the times for string compares
$ !
$ OBJDATE=F$CVTIME(OBJDATE)
$ SOURCEDATE=F$CVTIME(SOURCEDATE)
$ !
$ !	Check to see if there is a list of dependants
$ !
$ MAKEIT_ERR==1
$ IF P5 .EQS. "" THEN GOTO CHECK_SOURCE
$	P5LIST=","+P5+","
$	IDX=F$INTEGER(1)
$ 	COMP_LOOP:
$		DEP = F$ELEMENT (IDX, ",", P5LIST)
$		IF DEP .EQS. "," THEN GOTO CHECK_SOURCE
$		IF DEP .EQS. "" THEN GOTO CHECK_SOURCE
$		DEPDATE = ""
$		DEP1=DEP
$		IF (F$SEARCH (DEP1) .EQS. "") THEN -
			GOTO OOPS_NO_DEP
$		DEPDATE=F$FILE_ATTRIBUTES(DEP,"CDT")
$		DEPDATE=F$CVTIME(DEPDATE)
$		IF DEPDATE .GTS. OBJDATE THEN GOTO DO_COMP
$		IDX = IDX + 1
$		GOTO COMP_LOOP
$ !
$ CHECK_SOURCE:
$   MAKEIT_ERR==5
$	IF OBJDATE .GTS. SOURCEDATE THEN GOTO DONE
$   MAKEIT_ERR==1
$ DO_COMP:
$	IF P7 .NES. "" THEN P4=P4+"/OBJ=''P7'"
$	WRITE SYS$OUTPUT F$EDIT("$ ''P3' ''P1'.''P2'''P4'","UPCASE")
$	IF ONWARN THEN -
		ON WARNING THEN GOTO DEL_OBJ
$	IF ONERR THEN -
		ON ERROR THEN GOTO DEL_OBJ
$	IF ONCTLY THEN -
		ON CONTROL_Y THEN GOTO DEL_OBJ
$ !
$	ON SEVERE_ERROR THEN GOTO DEL_OBJ
$	IF MAKEIT$TEXT .NES. "" THEN -
		WRITE SYS$OUTPUT MAKEIT$TEXT
$ !
$ !  Do the processing specified.
$ !
$	'P3' 'SRC''P4'
$	MAKEIT$EXIT==$STATUS
$ DONE:
$	ON CONTROL_Y THEN STOP
$	IF F$MODE() .EQS. "BATCH" THEN VER = F$VERIFY(VER)
$ EXIT 'MAKEIT_ERR'
$ !
$ !  A CONTROL_Y was typed before the desired operation was initiated, just
$ !  return error, as the users wants to know about CONTROL_Y's
$ ! 
$ ERR_EXIT:
$   ON CONTROL_Y THEN GOTO ERR_EXIT
$   SAY "MAKEIT-E-CONTROLY, operation aborted with CONTROL_Y"
$	MAKEIT_ERR==3
$   GOTO DONE
$ !
$ !  An exception has occured while a non-LINK function was in progress.
$ !  Check the date of the file generated, and delete it if it is new.
$ !
$ DEL_OBJ:
$   WRITE SYS$OUTPUT F$MESSAGE($STATUS)
$	ON CONTROL_Y THEN STOP
$	MAKEIT_ERR==3
$	OBJDATE=""
$	IF (F$SEARCH (OBJ) .NES. "") THEN -
		OBJDATE=F$FILE_ATTRIBUTES(OBJ,"CDT")
$	IF OBJDATE .EQS. "" THEN -
$		OBJDATE="4-OCT-1900 00:00:00.00"
$	OBJDATE=F$CVTIME(OBJDATE)
$	IF OBJDATE .LTS. SOURCEDATE THEN GOTO DONE
$		SAY F$FAO("%MAKEIT-F-DELOBJ, object corrupted, deleting!/!_\!AS\",OBJ)
$		DELETE/LOG 'OBJ'
$	GOTO DONE
$ !
$ !  Check the dependent .OBJ's against the .EXE to see if a link is necessary.
$ !
$ LINK_IT:
$	MAKEIT_ERR==5
$	IDX = F$INTEGER("1")
$   EXE = F$PARSE (P2, ".EXE")
$	EXEDATE="4-OCT-1900 00:00:00.00"
$	IF (F$SEARCH (EXE) .NES. "") THEN -
		EXEDATE=F$FILE_ATTRIBUTES(EXE,"CDT")
$	EXEDATE=F$CVTIME(EXEDATE)
$	P1LIST=","+P1+","
$   IF P5 .NES. "" THEN P1LIST=P1LIST+P5+","
$ 	LINK_LOOP:
$		OBJ = F$ELEMENT (IDX, ",", P1LIST)
$		IF OBJ .EQS. "," THEN GOTO DONE
$		IF OBJ .EQS. "" THEN GOTO DONE
$		OBJ = F$PARSE (OBJ, ".OBJ")
$		OBJDATE = ""
$		IF (F$SEARCH (OBJ) .EQS. "") THEN -
			GOTO OOPS_NO_OBJ
		OBJDATE=F$FILE_ATTRIBUTES(OBJ,"CDT")
$		OBJDATE=F$CVTIME(OBJDATE)
$		IF EXEDATE .LTS. OBJDATE THEN GOTO DO_LINK
$		IDX = IDX + 1
$		GOTO LINK_LOOP
$ !
$ !  Set up the warning/error/control_y options and then do the LINK
$ !
$ DO_LINK:
$   MAKEIT_ERR== 1
$	WRITE SYS$OUTPUT F$EDIT("$ LINK ''P1'''P4'","UPCASE")
$	IF ONWARN THEN -
		ON WARNING THEN GOTO DEL_EXE
$	IF ONERR THEN -
		ON ERROR THEN GOTO DEL_EXE
$	IF ONCTLY THEN -
		ON CONTROL_Y THEN GOTO DEL_EXE
$!
$	ON SEVERE_ERROR THEN GOTO DEL_EXE
$	IF MAKEIT$TEXT .NES. "" THEN -
		WRITE SYS$OUTPUT MAKEIT$TEXT
$	LINK 'P1''P4'
$	MAKEIT$EXIT==$STATUS
$   GOTO DONE
$ !
$ !  An exception has occured while a LINK was in progress.
$ !  Check the .EXE's date, and delete it if it was created during this LINK.
$ !
$ DEL_EXE:
$	ON CONTROL_Y THEN STOP
$	MAKEIT_ERR==3
$	EXEDATE="1900-"
$	IF (F$SEARCH (EXE) .NES. "") THEN -
		EXEDATE="4-OCT-1900 00:00:00.00"
$	IF EXEDATE .LTS. NOW THEN GOTO DONE
$		SAY F$FAO("%MAKEIT-F-DELEXE, executable corrupted, deleting!/!_\!AS\",EXE)
$		DELETE/LOG 'EXE';
$	GOTO DONE
$ !
$ !   F$SEARCH() failed to find a file listed as a dependant .OBJ. Print a
$ !   message and exit with an error
$ !
$ OOPS_NO_OBJ:
$	SAY F$FAO("%MAKEIT-F-NOSUCHOBJ, can't find object file!/!_\!AS\",OBJ)
$	MAKEIT_ERR== 3
$	GOTO DONE
$ !
$ !   F$SEARCH() failed to find a file listed as a dependant, print a
$ !   message, and exit with an error
$ !
$ OOPS_NO_DEP:
$	SAY F$FAO("%MAKEIT-F-NOSUCHDEP, can't find dependant file!/!_\!AS\",DEP)
$	MAKEIT_ERR== 3
$	GOTO DONE
