******************************************************************************
*
*       Function:   RESUME_TASK
*       Usage:      call resume_task (SMB_stream_id, data_descr,
*                                                           SMB_request_id)
*       Purpose:    This routine is used to process the JBC's RESUME_TASK
*                   requests.  This routine will $RESUME any subprocesses
*                   that are associated with the stream indicated.
*       Output:     $SUSPND'd subprocesses are $RESUME'd.
*
******************************************************************************

        subroutine resume_task (stream, data, request)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer stream, request, i, stat
            record /dynam/ data
            external sys$resume
            integer sys$resume

*           Get only the stream specific info.

            last_idx = MAXPROCS+1

            call get_info (stream, data, request, last_idx)

*           Look for processes active in this stream.

            do i=1,MAXPROCS
                if ((procs(i).avail .eq. .false.) .and.
     .                              (procs(i).stream .eq. stream)) then

*                   Resume the process

                    stat = sys$resume (procs(i).pid,)
                    if ((stat.and.1).ne.1) then
                        call log_str (%val (stat),
     .                                      'Can''t resume process')
                    endif
                endif
            end do

            call reply (SS$_NORMAL, SMBMSG$K_RESUME_TASK, stream)
        end
